/*
   NoiascaBufferPrint - Hello World
   Test skecht to show a very simple implementation NoiascaBufferPrint on a Serial Interface

   write --> passthrough
   print --> using internal buffer

   2021-11-14 OK
 */

#include <NoiascaBufferPrint.h>

class Myclass : public NoiascaBufferPrint
{
  public:

    // a single write will be treated as passthrough only
    size_t write (uint8_t value)
    {
      return Serial.write(value);
    }
    // print all characters in the buffer to Serial
    void flush()
    {
      Serial.print(F("<flush>"));   // debug only: make the flush call visible 
      // transmit: output of internal buffer to an interface
      for (size_t i = 0; i < getBufferLength(); i++)
      {
        Serial.print(internal[i]);  // output to the hardware interface
      }
      resetBuffer(); // finally delete internal buffer - to be precise, set index back to 0
    }
};

Myclass myclass;

void setup() {
  Serial.begin(115200);

  myclass.setFlushAfter(31);
  
  myclass.print(" Test ");
  myclass.print(12345);
  myclass.print(" in HEX=");
  myclass.print(12345, HEX);
  myclass.println(67890);
  myclass.print(F(" F Test "));
  myclass.println();
  myclass.write('x');
  Serial.println();
}

void loop() {
  // put your main code here, to run repeatedly:

}
